<?php
/**
 * @package Resize_Vimeo
 * @author Josh Betz
 * @version 0.1
 */
/*
Plugin Name: Resize Vimeo
Plugin URI: http://joshbetz.com/2009/10/resize-vimeo/
Version: 0.1
Author: Josh Betz
Author URI: http://joshbetz.com
Description: Find Vimeo videos and resize them to a specified width, keeping the correct width-height ratio.
*/

add_filter( 'the_content', 'resize_vimeo' );

function resize_vimeo($content) {
	$new_width = '776';
	
	$objects = preg_split( '/object/', $content );
	foreach( $objects as $number => $object ) {
		if( preg_match( '/embed/', $object)) {
			$onlyobjects[$number] = $object;
			$dimensionsobject = $object;
			
			preg_match_all('/width="[0-9][0-9][0-9]"/', $dimensionsobject, $width);
			preg_match_all('/[0-9][0-9][0-9]/', $width[0][0], $width);
			preg_match_all('/height="[0-9][0-9][0-9]"/', $dimensionsobject, $height);
			preg_match_all('/[0-9][0-9][0-9]/', $height[0][0], $height);
			
			$width = $width[0][0];
			$height = $height[0][0];
			
			if( $width != 0 ) $ratio = $height / $width;
			else $ratio = 1;
			
			$new_height = round($ratio * $new_width);
			$object = str_replace( $height, $new_height, $object );
			$object = str_replace( $width, $new_width, $object );
			$newobject[$number] = $object;
		}
	}
	$print = str_replace( $onlyobjects, $newobject, $content );
	return $print;
}

?>